﻿/************************ 
Copyright Notice This objects content is copyright of Dynamic Manufacturing Solutions Inc 2011. 
All rights reserved. 
Any redistribution or reproduction of part or all of the contents in any form is prohibited. 
************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using System.Data.Entity;
using System.ComponentModel.DataAnnotations;

namespace DMS.NavHelpers
{
    /// <summary>
    /// 
    /// Used for Nav based data models.
    /// 
    /// 
    /// </summary>
    public abstract class DynamicsNavDataContext : DbContext
    {
        /// <summary>
        /// 
        /// Base class to use to take care of any nav specific.
        /// Based on work from:
        /// http://blog.bennymichielsen.be/2011/05/21/entity-framework-4-1-change-mappings-at-runtime/
        /// </summary>
        protected DynamicsNavDataContext( DbModelBuilder modelBuilder )
            : base( 
                DMS.NavHelpers.Properties.Settings.Default.DynamicsNavConnection,
                modelBuilder.Build(
                    new System.Data.SqlClient.SqlConnection( DMS.NavHelpers.Properties.Settings.Default.DynamicsNavConnection ) 
                ).Compile() )
        {
            // turn off the database initializer, we're not making
            // changes back to Dynamics Nav.

            Database.SetInitializer<DynamicsNavDataContext>(null);
        }

        //protected abstract System.Data.Entity.Infrastructure.DbCompiledModel GetCompiledModel();

        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            // only executed once per app domain.
            if (null != modelBuilder)
            {
                base.OnModelCreating(modelBuilder);

                // this is needed to prevent saving db changes
                // back into the database.
                modelBuilder.Conventions.Remove<System.Data.Entity.Infrastructure.IncludeMetadataConvention>();
            }
        }

        //public abstract void UpdateNavModels();
        

    }
}
