﻿/************************ 
Copyright Notice This objects content is copyright of Dynamic Manufacturing Solutions Inc 2011. 
All rights reserved. 
Any redistribution or reproduction of part or all of the contents in any form is prohibited. 
************************/
using System;
using System.Globalization;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace DMS.NavHelpers
{
   
    [AttributeUsage(AttributeTargets.Class)]
    public sealed class DynamicsNavTableAttribute : System.ComponentModel.DataAnnotations.TableAttribute
    {
        private string _dynamicsNavTableName = string.Empty;
        public DynamicsNavTableAttribute(string dynamicsNavTableName) :
            base(  GetCompanyTableName( dynamicsNavTableName) )
        
        {
            this._dynamicsNavTableName = dynamicsNavTableName;
        }
        public string DynamicsNavTableName
        {
            get
            {
                return _dynamicsNavTableName;
            } 

        }

          /// <summary>
        /// Contains a map of the users chosen company.
        /// </summary>
        private static Dictionary<string, string> _usersChosenCompany = new Dictionary<string, string>();

        /// <summary>
        /// Set the company.
        /// </summary>
        /// <param name="company"></param>
        public static void SetCurrentCompany(string company)
        {
            HttpContext current = HttpContext.Current;
            if (null != current )
            {
                if (!string.IsNullOrWhiteSpace(company))
                {
                    _usersChosenCompany[getKey()] = company;
                    
                }
            }
        }

        private static string getKey()
        {
            string key = string.Empty;
            HttpContext current = HttpContext.Current;
            if (null != current)
            {
                key = current.User.Identity.Name + current.Request.UserHostAddress;
            }
            else
            {
                // no context, return a key, just make it unique
                key = new Guid().ToString() + DateTime.Now.ToString() + new Random().ToString();
            }
            return key;
        }

        public static string GetCompanyTableName(string dynamicsNavTableName)
        {
            return string.Format(CultureInfo.InvariantCulture, "{0}${1}", GetCurrentCompany().Replace(".", "_"), dynamicsNavTableName);
        }

        public static string GetCurrentCompany()
        {
            string key = getKey();

            string company = string.Empty;
            if (_usersChosenCompany.ContainsKey(key))
            {
                company = _usersChosenCompany[key];
            }
            if (string.IsNullOrWhiteSpace(company))
            {
                company = Properties.Settings.Default.DynamicsNavCompany;
            }

            return company;
        }
    }

}